/*
 *
 * DocumentSearchContainer
 *
 */

import React, { PropTypes } from 'react';
import { connect } from 'react-redux';
import Helmet from 'react-helmet';
import { FormattedMessage } from 'react-intl';
import { createStructuredSelector } from 'reselect';
import makeSelectDocumentSearchContainer from './selectors';
import messages from './messages';
import DocumentSearchComponent from '../../components/DocumentSearchComponent';
import getSuggestions from './actions';

export class DocumentSearchContainer extends React.Component { // eslint-disable-line react/prefer-stateless-function
  render() {
    return (
      <div>
        <Helmet
          title="DocumentSearchContainer"
          meta={[
            { name: 'description', content: 'Description of DocumentSearchContainer' },
          ]}
        />
        <FormattedMessage {...messages.header} />

        :)

        <DocumentSearchComponent { ...this.props } />
        <input id="aqq" onChange={this.props.onChangeUsername} />
        {/*<input id="aqq" onChange={test(this)} />*/}
      </div>
    );
  }
}

DocumentSearchContainer.propTypes = {
  dispatch: PropTypes.func.isRequired,
  onChangeUsername: React.PropTypes.func,
};

const mapStateToProps = createStructuredSelector({
  DocumentSearchContainer: makeSelectDocumentSearchContainer(),
});

function mapDispatchToProps(dispatch) {
  return {
    onChangeUsername: (evt) => dispatch(getSuggestions(evt.target.value)),
    // onChangeUsername: (evt) => alert('a'), 
    // onChangeUsername:(evt)=>{
    //   console.log('aqq');      
    //   dispatch(getSuggestions());
    //  }, 
    dispatch,
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(DocumentSearchContainer);
